Bug 1022493 - Regression in ECC build of openssl affecting TLS connections
Regression in ECC build of openssl affecting TLS connections
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: openssl (Show other bugs)
19
x86_64 Linux
unspecified Severity high
: ---
: ---
Assigned To: Tomas Mraz
Fedora Extras Quality Assurance
: Reopened
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2013-10-23 08:13 EDT by Vladimir Mosgalin
Modified: 2013-11-13 22:36 EST (History)
1 user (show)

See Also:
Fixed In Version: openssl-1.0.1e-30.fc18
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2013-10-30 23:00:20 EDT
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Vladimir Mosgalin 2013-10-23 08:13:38 EDT
Description of problem:
After openssl upgrade, jabber client (gajim) lost ability to do TLS connections to certain jabber servers. Upon investigation, I found out that new version of openssl built with ECC support refuses to negotiate with this server.

For the record, openssl in ubuntu and debian (with ECC support) works just fine.

In the output below, latest openssl prints "Cipher    : 0000" while previous version printed "Cipher    : EDH-RSA-DES-CBC3-SHA" (among other differences).

Version-Release number of selected component (if applicable):
openssl-1.0.1e-28.fc19.x86_64


How reproducible:
Always.


Steps to Reproduce:
Run
$ openssl s_client -host jabber.online-solutions.ru -port 5222 -starttls xmpp


Actual results:

CONNECTED(00000003)

depth=0 CN = jabber.online-solutions.ru
verify error:num=18:self signed certificate
verify return:1
depth=0 CN = jabber.online-solutions.ru
verify return:1
140207621224352:error:100AE081:elliptic curve routines:EC_GROUP_new_by_curve_name:unknown group:ec_curve.c:316:
140207621224352:error:1408D010:SSL routines:SSL3_GET_KEY_EXCHANGE:EC lib:s3_clnt.c:1641:
---
Certificate chain
 0 s:/CN=jabber.online-solutions.ru
   i:/CN=jabber.online-solutions.ru
---
Server certificate
-----BEGIN CERTIFICATE-----
MIIDBTCCAe2gAwIBAgIIWgBEgQ1XCP8wDQYJKoZIhvcNAQEFBQAwJTEjMCEGA1UE
AwwaamFiYmVyLm9ubGluZS1zb2x1dGlvbnMucnUwHhcNMTIwMTI0MDQwNzA4WhcN
MTYxMjI4MDQwNzA4WjAlMSMwIQYDVQQDDBpqYWJiZXIub25saW5lLXNvbHV0aW9u
cy5ydTCCASIwDQYJKoZIhvcNAQEBBQADggEPADCCAQoCggEBAO43oiFleEbzbCHC
DpYI3DgFJhxqGikuWmZkpRnveZbhCYDrMuMJQK7xWsS22nMm0YdIVK3cIVB64G0s
q9e156TJevraRnqCFaG4FZz00Jxn1GQmqYxmKV3lmcm596Y0NfSbtMXOAA2Suz3V
ZPcIif0tDpR/VLEN562FrhHS3O36WqDy32fraV4fDTloFUBx403wTk3NSc4APOUQ
jKF4YrsJwiKkWMkcKA33Csrw86bEkHuSaPbUeVa07HWUVrMMkYglx40Mv5H/ks1T
itRswmVPjhaIKNz3aolR3GFk4zv+BKLYoQMiylqTH1WNgtj+pHKKQ8NOLiTxxRoM
aT+hNzcCAwEAAaM5MDcwNQYDVR0RBC4wLKAqBggrBgEFBQcIBaAeDBwqLmphYmJl
ci5vbmxpbmUtc29sdXRpb25zLnJ1MA0GCSqGSIb3DQEBBQUAA4IBAQAAcoSVpiir
rSgurfcIRmNg9XL5huYdKlwnLFmUX2tnx5Qc0AI3Sii55agA69Dg9sYvdgUi0lNH
SgE8e7Tr+8VFLdAgrQOrFNKq7W94v4R2/AgiSa4Xof7nRKDNKh1P1TFwtbtv1Vcj
WV5SJIj2YvmbQS00RinsWL6Ihvs2PfSRivGjDHMdyYjZOFLg2YUOg1OckKXBm1X/
KWLRfnz/GBMpJtAXbqI4kWtThqTdlNpoPTSPTmHou6VohRe4EaF7SnnxQRI4vkRj
1ciVQFvzlJQuFj0C8dhmULCm8p041WATQrKuT4LFKQA3P7Tu2EkuB1QTbVwDTfUr
EVUBMwNH1k2A
-----END CERTIFICATE-----
subject=/CN=jabber.online-solutions.ru
issuer=/CN=jabber.online-solutions.ru
---
No client certificate CA names sent
---
SSL handshake has read 1802 bytes and written 0 bytes
---
New, (NONE), Cipher is (NONE)
Server public key is 2048 bit
Secure Renegotiation IS supported
Compression: NONE
Expansion: NONE
SSL-Session:
    Protocol  : TLSv1
    Cipher    : 0000
    Session-ID: 5267B950A88F56E5544099A31CB9457DC74B27FDE26877CAFC51426929732A1E
    Session-ID-ctx: 
    Master-Key: 
    Key-Arg   : None
    Krb5 Principal: None
    PSK identity: None
    PSK identity hint: None
    Start Time: 1382529346
    Timeout   : 300 (sec)
    Verify return code: 18 (self signed certificate)
---


Expected results:

(Output of the same command from openssl-1.0.1e-4.fc19.x86_64):
CONNECTED(00000003)
depth=0 CN = jabber.online-solutions.ru
verify error:num=18:self signed certificate
verify return:1
depth=0 CN = jabber.online-solutions.ru
verify return:1
---
Certificate chain
 0 s:/CN=jabber.online-solutions.ru
   i:/CN=jabber.online-solutions.ru
---
Server certificate
-----BEGIN CERTIFICATE-----
MIIDBTCCAe2gAwIBAgIIWgBEgQ1XCP8wDQYJKoZIhvcNAQEFBQAwJTEjMCEGA1UE
AwwaamFiYmVyLm9ubGluZS1zb2x1dGlvbnMucnUwHhcNMTIwMTI0MDQwNzA4WhcN
MTYxMjI4MDQwNzA4WjAlMSMwIQYDVQQDDBpqYWJiZXIub25saW5lLXNvbHV0aW9u
cy5ydTCCASIwDQYJKoZIhvcNAQEBBQADggEPADCCAQoCggEBAO43oiFleEbzbCHC
DpYI3DgFJhxqGikuWmZkpRnveZbhCYDrMuMJQK7xWsS22nMm0YdIVK3cIVB64G0s
q9e156TJevraRnqCFaG4FZz00Jxn1GQmqYxmKV3lmcm596Y0NfSbtMXOAA2Suz3V
ZPcIif0tDpR/VLEN562FrhHS3O36WqDy32fraV4fDTloFUBx403wTk3NSc4APOUQ
jKF4YrsJwiKkWMkcKA33Csrw86bEkHuSaPbUeVa07HWUVrMMkYglx40Mv5H/ks1T
itRswmVPjhaIKNz3aolR3GFk4zv+BKLYoQMiylqTH1WNgtj+pHKKQ8NOLiTxxRoM
aT+hNzcCAwEAAaM5MDcwNQYDVR0RBC4wLKAqBggrBgEFBQcIBaAeDBwqLmphYmJl
ci5vbmxpbmUtc29sdXRpb25zLnJ1MA0GCSqGSIb3DQEBBQUAA4IBAQAAcoSVpiir
rSgurfcIRmNg9XL5huYdKlwnLFmUX2tnx5Qc0AI3Sii55agA69Dg9sYvdgUi0lNH
SgE8e7Tr+8VFLdAgrQOrFNKq7W94v4R2/AgiSa4Xof7nRKDNKh1P1TFwtbtv1Vcj
WV5SJIj2YvmbQS00RinsWL6Ihvs2PfSRivGjDHMdyYjZOFLg2YUOg1OckKXBm1X/
KWLRfnz/GBMpJtAXbqI4kWtThqTdlNpoPTSPTmHou6VohRe4EaF7SnnxQRI4vkRj
1ciVQFvzlJQuFj0C8dhmULCm8p041WATQrKuT4LFKQA3P7Tu2EkuB1QTbVwDTfUr
EVUBMwNH1k2A
-----END CERTIFICATE-----
subject=/CN=jabber.online-solutions.ru
issuer=/CN=jabber.online-solutions.ru
---
No client certificate CA names sent
---
SSL handshake has read 1998 bytes and written 511 bytes
---
New, TLSv1/SSLv3, Cipher is EDH-RSA-DES-CBC3-SHA
Server public key is 2048 bit
Secure Renegotiation IS supported
Compression: NONE
Expansion: NONE
SSL-Session:
    Protocol  : TLSv1
    Cipher    : EDH-RSA-DES-CBC3-SHA
    Session-ID: 5267BA0C313BF3EC327CA2FCFB79615FAC5D1BFAC9382BE34F9424E7DD7D0BAB
    Session-ID-ctx: 
    Master-Key: 69254D83AF2B44A39E2227013FDB4BF69B1788C6469A3FCA182068AAF1E51D49A794E76491E3675DBC0C825DB2081FEC
    Key-Arg   : None
    Krb5 Principal: None
    PSK identity: None
    PSK identity hint: None
    Start Time: 1382529548
    Timeout   : 300 (sec)
    Verify return code: 18 (self signed certificate)
---
DONE



Additional info:
If anyone encounters same problem - "yum downgrade openssl openssl-libs openssl-devel" is workaround that doesn't seem to break anything
Comment 1 Fedora Update System 2013-10-24 09:09:54 EDT
openssl-1.0.1e-29.fc19 has been submitted as an update for Fedora 19.
https://admin.fedoraproject.org/updates/openssl-1.0.1e-29.fc19
Comment 2 Fedora Update System 2013-10-24 09:10:08 EDT
openssl-1.0.1e-29.fc20 has been submitted as an update for Fedora 20.
https://admin.fedoraproject.org/updates/openssl-1.0.1e-29.fc20
Comment 3 Fedora Update System 2013-10-24 09:10:31 EDT
openssl-1.0.1e-29.fc18 has been submitted as an update for Fedora 18.
https://admin.fedoraproject.org/updates/openssl-1.0.1e-29.fc18
Comment 4 Fedora Update System 2013-10-24 13:46:27 EDT
Package openssl-1.0.1e-29.fc20:
* should fix your issue,
* was pushed to the Fedora 20 testing repository,
* should be available at your local mirror within two days.
Update it with:
# su -c 'yum update --enablerepo=updates-testing openssl-1.0.1e-29.fc20'
as soon as you are able to.
Please go to the following url:
https://admin.fedoraproject.org/updates/FEDORA-2013-19845/openssl-1.0.1e-29.fc20
then log in and leave karma (feedback).
Comment 5 Vladimir Mosgalin 2013-10-25 06:26:23 EDT
This bug is fixed for me with openssl-1.0.1e-29.fc19. Thanks.
Comment 6 Fedora Update System 2013-10-25 20:54:33 EDT
openssl-1.0.1e-29.fc19 has been pushed to the Fedora 19 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 7 Fedora Update System 2013-10-29 12:42:15 EDT
openssl-1.0.1e-30.fc18 has been submitted as an update for Fedora 18.
https://admin.fedoraproject.org/updates/openssl-1.0.1e-30.fc18
Comment 8 Fedora Update System 2013-10-29 12:42:47 EDT
openssl-1.0.1e-30.fc19 has been submitted as an update for Fedora 19.
https://admin.fedoraproject.org/updates/openssl-1.0.1e-30.fc19
Comment 9 Fedora Update System 2013-10-29 12:43:07 EDT
openssl-1.0.1e-30.fc20 has been submitted as an update for Fedora 20.
https://admin.fedoraproject.org/updates/openssl-1.0.1e-30.fc20
Comment 10 Fedora Update System 2013-10-29 21:51:51 EDT
Package openssl-1.0.1e-30.fc18:
* should fix your issue,
* was pushed to the Fedora 18 testing repository,
* should be available at your local mirror within two days.
Update it with:
# su -c 'yum update --enablerepo=updates-testing openssl-1.0.1e-30.fc18'
as soon as you are able to.
Please go to the following url:
https://admin.fedoraproject.org/updates/FEDORA-2013-20263/openssl-1.0.1e-30.fc18
then log in and leave karma (feedback).
Comment 11 Fedora Update System 2013-10-30 23:00:20 EDT
openssl-1.0.1e-30.fc19 has been pushed to the Fedora 19 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 12 Fedora Update System 2013-11-10 01:32:18 EST
openssl-1.0.1e-29.fc20 has been pushed to the Fedora 20 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 13 Fedora Update System 2013-11-10 01:52:44 EST
openssl-1.0.1e-30.fc20 has been pushed to the Fedora 20 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 14 Fedora Update System 2013-11-13 22:36:47 EST
openssl-1.0.1e-30.fc18 has been pushed to the Fedora 18 stable repository.  If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.